#include <amxmodx>

#pragma semicolon 1

#define PLUGIN "Won Score"
#define VERSION "1.0"
#define AUTHOR "theRoone"

new stSyncHudCreate;

new ct_score, terrorist_score;
new ct_won, terrorist_won;

new red = 255, green = 255, blue = 20;
new bool: antibug;

new CVAR_WonScore_Rounds, CVAR_WonScore_Level[3], Cvar_WonScore_Enabled;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_event("TeamScore", "team_score", "a");
	register_event("HLTV", "Event_NewRound", "a", "1=0", "2=0");
	
	CVAR_WonScore_Rounds	= 	register_cvar("sv_wonscore_rounds"	, "10"	);	// Сколько раундов надо будет выиграть, если отключена сортировка
	Cvar_WonScore_Enabled	= 	register_cvar("sv_wonscore_enabled"	, "1"	);	// Если поставить 1, будет работать сортировка. Раунды зависят от количества игроков.
	CVAR_WonScore_Level[0]	= 	register_cvar("sv_wonscore_level1"	, "20"	);	// Сколько раундов надо будет выиграть, если сортировка включена (Игроков: 0 - 13)
	CVAR_WonScore_Level[1]	= 	register_cvar("sv_wonscore_level2"	, "15"	);  // Сколько раундов надо будет выиграть, если сортировка включена (Игроков: 14 - 24)
	CVAR_WonScore_Level[2]	= 	register_cvar("sv_wonscore_level3"	, "12"	);  // Сколько раундов надо будет выиграть, если сортировка включена (Игроков: 25 - 32)

	stSyncHudCreate = CreateHudSyncObj();
}

public client_putinserver(id)
	set_task(1.0, "score_round", id, _, _, "b");
	
public client_disconnected(id)
	remove_task(id);
	
public Event_NewRound() {
	new Name_wonner[64];
	new Wonner_id; Wonner_id = 0;
	
	if(antibug) {
		antibug = false;
		return PLUGIN_CONTINUE;
	}
	
	if(ct_score == Get_RoundsCount()) {
		ct_won ++;
		formatex(Name_wonner, charsmax(Name_wonner), "Контр-Террористов");
		antibug = true;
		Wonner_id = 1;
	}
	else if(terrorist_score == Get_RoundsCount()) {
		terrorist_won ++;
		formatex(Name_wonner, charsmax(Name_wonner), "Террористов");
		antibug = true;
		Wonner_id = 2;
	}
	else return PLUGIN_CONTINUE;

	if(ct_won > terrorist_won) {
		red = 0;
		green = 0;
		blue = 255;
	}
	else if(ct_won < terrorist_won) {
		red = 255;
		green = 0;
		blue = 0;
	}
	else {
		red = 255;
		green = 255; 
		blue = 20;
	}
	
	for(new i = 0; i < 5; i++)
		client_print_color(0, Wonner_id > 1 ? print_team_red : print_team_blue, "^4Поздравляем команду ^3%s ^1за победу в ^4%d %s!", Name_wonner, Get_RoundsCount(), get_text_chat(Get_RoundsCount()));
	
	server_cmd("sv_restartround 1");
	return PLUGIN_CONTINUE;
}

public team_score() {
	new team[32];
	read_data(1, team, 31);
	if (equal(team, "CT"))
		ct_score = read_data(2);
	else if (equal(team, "TERRORIST"))
		terrorist_score = read_data(2);
}

public score_round(id) {
	if(!is_user_alive(id)) {
		//set_hudmessage(red, green, blue, -0.45, 0.05, 0, 1.0, 1.0, 0.1, 0.2, -1);
		set_dhudmessage(red, green, blue, -0.45, 0.0, 0, 1.0, 1.0, 0.1, 0.2);
		//ShowSyncHudMsg(id, stSyncHudCreate, "
		show_dhudmessage(id, "\
		Каждые %d %s обнуление счёта\
		^n     Террористы - %d | %d - Контры", Get_RoundsCount(), get_text_hud(Get_RoundsCount()), terrorist_won, ct_won);
	}
}

stock get_text_hud(tm) {
	new ost = tm % 10, ost2 = tm % 100, buff[14];
	
	if(ost2 >= 5 && ost2 <= 20)
		buff = "побед";
	else {
		switch(ost) {
			case 1:			buff = "победа";
			case 2..4:		buff = "победы";
			case 0, 5..9:	buff = "побед";
		}
	}
	return buff;
}

stock get_text_chat(tm) {
	new ost = tm % 10, ost2 = tm % 100, buff[16];
	
	if(ost2 >= 5 && ost2 <= 20)
		buff = "раундах";
	else {
		switch(ost) {
			case 1:			buff = "раунд";
			case 2..4:		buff = "раунда";
			case 0, 5..9:	buff = "раундах";
		}
	}
	return buff;
}

Get_RoundsCount()
{
	if(!get_pcvar_num(Cvar_WonScore_Enabled)) {
		return get_pcvar_num(CVAR_WonScore_Rounds);
	}

	switch(get_playersnum())
	{
		case 0..13: 	return get_pcvar_num(CVAR_WonScore_Level[0]);	// Low
		case 14..24: 	return get_pcvar_num(CVAR_WonScore_Level[1]);	// Medium
		case 25..32: 	return get_pcvar_num(CVAR_WonScore_Level[2]);	// High
	}

	return 0;
}